require "yaml"
module PersonalPluginGenerator
  class Engine < ::Rails::Engine
    begin
      initializer "personal_plugin_generator" do
        OrbitApp.registration "PersonalPluginGenerator", :type => "OrbitMemberModule" do
          base_url File.expand_path File.dirname(__FILE__)
          categorizable
          authorizable
          side_bar do
                head_label_i18n 'personal_plugin_generator.personal_plugin_generator', icon_class: "icons-graduation"
                available_for "users"
                active_for_controllers (['admin/personal_plugin_fields'])
                head_link_path "admin_personal_plugin_fields_path"
                context_link 'personal_plugin_generator.personal_plugin_generator',
                                      :link_path=>"admin_personal_plugin_fields_path" ,
                                      :priority=>1,
                                      :active_for_action=>{'admin/personal_plugin_fields'=>'index'},
                                      :available_for => 'users'
          end
        end
      end
    rescue
      initializer "personal_plugin_generator" do
        OrbitApp.registration "PersonalPluginGenerator", :type => "ModuleApp" do
          base_url File.expand_path File.dirname(__FILE__)
          categorizable
          authorizable
          side_bar do
                head_label_i18n 'personal_plugin_generator.personal_plugin_generator', icon_class: "icons-graduation"
                available_for "users"
                active_for_controllers (['admin/personal_plugin_fields'])
                head_link_path "admin_personal_plugin_fields_path"
                context_link 'personal_plugin_generator.personal_plugin_generator',
                                      :link_path=>"admin_personal_plugin_fields_path" ,
                                      :priority=>1,
                                      :active_for_action=>{'admin/personal_plugin_fields'=>'index'},
                                      :available_for => 'users'
          end
        end
      end
    end
  end
end