class PluginTemplate
    include Mongoid::Document
    include Mongoid::Timestamps
    include OrbitModel::Status
    include MemberHelper
    include Slug


    col_fields

    plugin_template_related_files_fields

parse_again_start
    belongs_to :plugin_template_related
parse_again_end
    
    field :rss2_id
    belongs_to :member_profile

    scope :sort_for_frontend, ->{ where(:is_hidden=>false).order_by(plugin_template_sort_hash) }

parse_again_start
    member_methods_define
parse_again_end
    before_save do
      before_save_codes
    end
    def parse_time(time_str)
      DateTime.parse("0000-01-01 " + time_str) 
    end
    def self.get_plugin_datas_to_member(datas)

	    fields_to_show = col_name_to_show

	    fields_to_remove = []

    	pd_title = []

	    fields_to_show.each do |t|
	      if (self.fields[t].type.to_s == "String" || self.fields[t].type.to_s == "Object" rescue false)
	        fields_to_remove << t if (datas.where(t.to_sym.ne => nil, t.to_sym.ne => "").count == 0 rescue false)
	      elsif (self.relations.include?(t.pluralize) rescue false)
            fields_to_remove << t if (datas.where(t.pluralize.to_sym.ne=>[]).count == 0 rescue false)
          else
	        fields_to_remove << t if (datas.where(t.to_sym.ne => nil).count == 0 rescue false)
	      end
	      pd_title <<  {
	          "plugin_data_title" => I18n.t("personal_plugin_template.#{t}")
	        } if !fields_to_remove.include?(t)
	    end

	    fields_to_show = fields_to_show - fields_to_remove

	    plugin_datas = datas.sort_for_frontend.collect.with_index do |p,index|

	      pd_data = []
	      fields_to_show.collect do |t|
            pd_data << { "data_title" => p.display_field(t) }
	      end

	      {
	        "pd_datas" => pd_data,
	        "type-sort" => (p.course_category.sort_position.to_i rescue 1000),
	        "sort-index" => index
	      }

	    end
	    plugin_datas = plugin_datas.sort_by{|pd| [pd["type-sort"], pd["sort-index"]]}
	    return [pd_title,plugin_datas]
	    
	end

    def get_plugin_data(fields_to_show)
	    plugin_datas = []
	    fields_to_show.each do |field|
	      plugin_data = self.get_plugin_field_data(field) rescue nil
	      next if plugin_data.blank? or plugin_data['value'].blank?
	      plugin_datas << plugin_data
	    end
	    plugin_datas
    end

  def get_plugin_field_data(field)
    plugin_template = self
    value_case_codes

    value = (value =~ /\A#{URI::regexp(['http', 'https'])}\z/) ? "<a href='#{value}' target='blank'>#{value}</a>" : value
    
    {
      "key"=>field,
      "title_class"=>"plugin_template-#{field.gsub('_','-')}-field",
      "value_class"=>"plugin_template-#{field.gsub('_','-')}-value",
      "title"=>I18n.t('personal_plugin_template.'+field),
      "value"=>value
    }
  end

  def display_field(field,text_only=false)
    plugin_template = self
    display_field_code
  end

end
